package com.supervision;

import com.supervision.service.IrKnowledgeService;
import com.supervision.util.mybatis.RowSqlMapper;
import freemarker.cache.StringTemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.io.IOException;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
@RunWith(SpringJUnit4ClassRunner.class)
@RequiredArgsConstructor
class AskApplicationTests {

    @Autowired
    private IrKnowledgeService irKnowledgeService;



    @Autowired
    private RowSqlMapper sqlMapper;
    @Test
    void rowSqlMapperTest() {

        HashMap<String, Object> params = new HashMap<>();
        params.put("id", "111");
        //params.put("dept_name","沈阳公安");
        // and dept_name= #{dept_name}
        List<Map<String, Object>> maps = sqlMapper.selectList("<script> select * from interro_robot.ir_robot_config where id = #{id} <if test= \"dept_name != null\">" +
                " and dept_name= #{dept_name} </if> </script>",params);
        System.out.println(maps);
    }

    @Autowired
    private Configuration databaseFreemarkerConfiguration;

    @Test
    void dbFreemarkerLoadTest() throws IOException, TemplateException {

        Template temp = databaseFreemarkerConfiguration.getTemplate("1770984442920292354");
        StringWriter writer = new StringWriter();
        HashMap<String, Object> params = new HashMap<>();
        params.put("jykh_count","ss");
        temp.process(params, writer);
        System.out.println(writer);
        writer.close();

    }


    @Test
    void stringTemplateLoaderTest() throws IOException, TemplateException {
        Configuration cfg = new Configuration(Configuration.VERSION_2_3_30);

        // 创建一个 StringTemplateLoader 对象
        StringTemplateLoader stringLoader = new StringTemplateLoader();

        // 添加模板到 StringTemplateLoader 中
        String templateContent = "Hello, ${user}!";
        stringLoader.putTemplate("myTemplate", templateContent);

        // 将 StringTemplateLoader 添加到 Configuration 中
        cfg.setTemplateLoader(stringLoader);

        // 获取模板
        Template template = cfg.getTemplate("myTemplate");

        // 创建模板数据模型
        Map<String, Object> data = new HashMap<>();
        data.put("user", "John");

        // 渲染模板
        StringWriter output = new StringWriter();
        template.process(data, output);

        // 打印输出结果
        System.out.println(output.toString());
    }



}
